require "eddn/client/version"
require 'zlib'
require 'ffi-rzmq'
require 'json'

module Eddn
  class Client
    def initialize url="tcp://eddn-relay.elite-markets.net:9500", opts={}
      @url = url
      @opts = opts
    end
    def connect
      @subscriber = context.socket ZMQ::SUB
      @subscriber.connect(@url)
      @subscriber.setsockopt(ZMQ::SUBSCRIBE, "")

      @poller = ZMQ::Poller.new
      @poller.register(@subscriber, ZMQ::POLLIN)
    end


    def poll_blocking
      while (data = poll).nil?; sleep 0.001; end
      return data
    end
    def poll
      p = @poller.poll
      if p
        @subscriber.recv_string(msec ='')
        inflate = Zlib::Inflate.new
        return JSON.parse(Zlib::Inflate.inflate(msec))
      else
        return nil
      end
    end
    private
    def context
      @context ||= ZMQ::Context.new
    end
  end
end
